<?php
	class freekassaPayment extends payment {
		public function validate() { return true; }

		public static function getOrderId() {
			return (int) getRequest('MERCHANT_ORDER_ID');
		}

		public function process($template = null) {
			$this->order->order();
			$merchant_id = $this->object->fk_merchant_id;
			$secret_1 = $this->object->fk_secret_1;
			$out_amount = number_format($this->order->getActualPrice(), 2, '.', '');
			$order_id = $this->order->id;
			$sign = md5($merchant_id.":".$out_amount.":".$secret_1.":".$order_id);

			$param = array();
			$param['formAction'] = "http://www.free-kassa.ru/merchant/cash.php";
			$param['merchant_id'] = $merchant_id;
			$param['out_amount'] = $out_amount;
			$param['order_id'] = $order_id;
			$param['sign'] = $sign;
			$this->order->setPaymentStatus('initialized');

$FORMS = Array();
$FORMS = "<form action=".$param['formAction']." method='get' name='form_fk'>
<input type='hidden' name='m' value=".$param['merchant_id']." />
<input type='hidden' name='oa' value=".$param['out_amount']." />
<input type='hidden' name='o' value=".$param['order_id']." />
<input type='hidden' name='s' value=".$param['sign']." />
<input type='submit' value='Оплатить' />
</form>
<script type='text/javascript'>document.form_fk.submit();</script>";

echo $FORMS; exit();

			list($templateString) = def_module::loadTemplates("emarket/payment/freekassa/".$template, "form_block");
			return def_module::parseTemplate($templateString, $param);
		}

		public function poll() {
			$out_amount  = getRequest("AMOUNT");
			$sign    = getRequest("SIGN");
			$order_id = getRequest("MERCHANT_ORDER_ID");
			$secret_2 = $this->object->fk_secret_2;
			$merchant_id = $this->object->fk_merchant_id;
			$out_amount = (float) $out_amount;
			$orderActualPrice = number_format($this->order->getActualPrice(), 2, '.', '');
			
			$my_sign = md5($merchant_id.":".$out_amount.":".$secret_2.":".$order_id);

			$buffer = outputBuffer::current();
			$buffer->clear();
			$buffer->contentType("text/plain");
			if ( ($my_sign == $sign) && ($orderActualPrice == $out_amount) ) {
				$this->order->setPaymentStatus("accepted");
				$buffer->push("OK $order_id");
			} else {
				$buffer->push("failed");
			}
			$buffer->end();
		}
	};
?>